"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function CollapseMenu(props) {
  var onChange = props.onChange,
      title = props.schema.title,
      collapsed = props.collapsed;
  var _props$uiSchema = props.uiSchema,
      _props$uiSchema$colla = _props$uiSchema.collapse.icon;
  _props$uiSchema$colla = _props$uiSchema$colla === undefined ? {} : _props$uiSchema$colla;
  var _props$uiSchema$colla2 = _props$uiSchema$colla.enabled,
      enabled = _props$uiSchema$colla2 === undefined ? "glyphicon glyphicon-chevron-down" : _props$uiSchema$colla2,
      _props$uiSchema$colla3 = _props$uiSchema$colla.disabled,
      disabled = _props$uiSchema$colla3 === undefined ? "glyphicon glyphicon-chevron-right" : _props$uiSchema$colla3,
      _props$uiSchema$separ = _props$uiSchema.separate,
      separate = _props$uiSchema$separ === undefined ? true : _props$uiSchema$separ,
      _props$uiSchema$wrapC = _props$uiSchema.wrapClassName,
      wrapClassName = _props$uiSchema$wrapC === undefined ? "lead" : _props$uiSchema$wrapC;

  return _react2.default.createElement(
    "div",
    { className: wrapClassName },
    _react2.default.createElement(
      "span",
      null,
      title
    ),
    "\xA0",
    _react2.default.createElement(
      "a",
      { onClick: onChange },
      _react2.default.createElement("i", { className: collapsed ? disabled : enabled })
    ),
    separate && _react2.default.createElement("hr", null)
  );
}

var CollapsibleField = function (_React$Component) {
  _inherits(CollapsibleField, _React$Component);

  function CollapsibleField(props) {
    _classCallCheck(this, CollapsibleField);

    var _this = _possibleConstructorReturn(this, (CollapsibleField.__proto__ || Object.getPrototypeOf(CollapsibleField)).call(this, props));

    _this.handleCollapsed = function () {
      _this.setState(function (state) {
        return { collapsed: !state.collapsed };
      });
    };

    var _props$uiSchema$colla4 = props.uiSchema.collapse;
    _props$uiSchema$colla4 = _props$uiSchema$colla4 === undefined ? {} : _props$uiSchema$colla4;
    var _props$uiSchema$colla5 = _props$uiSchema$colla4.active,
        active = _props$uiSchema$colla5 === undefined ? true : _props$uiSchema$colla5;


    _this.state = { collapsed: active };
    return _this;
  }

  _createClass(CollapsibleField, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          schema = _props.schema,
          uiSchema = _props.uiSchema,
          fields = _props.registry.fields;
      var collapsed = this.state.collapsed;
      var field = uiSchema.collapse.field;

      var CollapseElement = fields[field];

      return _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(CollapseMenu, { schema: schema, uiSchema: uiSchema, collapsed: collapsed, onChange: this.handleCollapsed }),
        _react2.default.createElement(
          "div",
          { className: "form-group" },
          !collapsed && _react2.default.createElement(CollapseElement, this.props)
        )
      );
    }
  }]);

  return CollapsibleField;
}(_react2.default.Component);

exports.default = CollapsibleField;